#include <cstdio>
#include <algorithm>
#include <iostream>
#include <queue>

using namespace std;

const int MAXN = 100000 + 5;

int n, m, par[MAXN], ans1, sz[MAXN];
long long r;
priority_queue<int> pq;

int fs (int k) {
	if (k != par[k])
		par[k] = fs(par[k]);
	return par[k];
}

int main () {
	freopen("teedsis.txt", "r", stdin);
	freopen("teedval.txt", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin >> n >> m >> r;
	for(int i = 1; i <= n; i++)
		par[i] = i;
	for(int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		par[fs(x)] = fs(y);
	}
	for(int i = 1; i <= n; i++)
		++sz[fs(i)];

	long long te = -m;
	for(int i = 1; i <= n; i++) if (sz[i] > 0) {
		pq.push(sz[i]);
		te += sz[i] * 1LL * (sz[i] - 1) / 2;
	}

	ans1 = max(1LL, (int)pq.size() - r);

	r -= te;
	if (r <= 0) {
		cout << ans1 << " " << pq.size() << endl;
		return 0;
	}

	while (pq.size() > 1 && r > 0) {
		long long x = (int)pq.top();
		pq.pop();
		long long y = (int)pq.top();
		pq.pop();
		if (x * y < r) {
			r -= x * y;
			pq.push(x + y);
		} else {
			r = 0;
			pq.push(-1);
			break;
		}
	}

	cout << ans1 << " " << pq.size() << endl;

	return 0;
}
